Index: include/libroaryiff/libroaryiff.h
===================================================================
--- include/libroaryiff/libroaryiff.h	(revision 341)
+++ include/libroaryiff/libroaryiff.h	(revision 688)
@@ -1,3 +1,25 @@
 //libroaryiff.h:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - August 2008
+ *
+ *  This file is part of libroaryiff a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroaryiff is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
 
 #ifndef _LIBROARYIFF_H_
Index: libroaryiff/audiocd.c
===================================================================
--- libroaryiff/audiocd.c	(revision 343)
+++ libroaryiff/audiocd.c	(revision 688)
@@ -1,3 +1,25 @@
 //audiocd.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - August 2008
+ *
+ *  This file is part of libroaryiff a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroaryiff is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
 
 #include <libroaryiff.h>
Index: libroaryiff/connection.c
===================================================================
--- libroaryiff/connection.c	(revision 342)
+++ libroaryiff/connection.c	(revision 688)
@@ -1,3 +1,25 @@
 //connection.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - August 2008
+ *
+ *  This file is part of libroaryiff a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroaryiff is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
 
 #include <libroaryiff.h>
Index: libroaryiff/ctl.c
===================================================================
--- libroaryiff/ctl.c	(revision 343)
+++ libroaryiff/ctl.c	(revision 688)
@@ -1,3 +1,25 @@
 //ctl.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - August 2008
+ *
+ *  This file is part of libroaryiff a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroaryiff is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
 
 #include <libroaryiff.h>
Index: libroaryiff/libroaryiff.c
===================================================================
--- libroaryiff/libroaryiff.c	(revision 338)
+++ libroaryiff/libroaryiff.c	(revision 688)
@@ -1,3 +1,25 @@
 //libroaryiff.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - August 2008
+ *
+ *  This file is part of libroaryiff a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroaryiff is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
 
 #include <libroaryiff.h>
Index: libroaryiff/playback.c
===================================================================
--- libroaryiff/playback.c	(revision 343)
+++ libroaryiff/playback.c	(revision 688)
@@ -1,3 +1,25 @@
 //playback.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - August 2008
+ *
+ *  This file is part of libroaryiff a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroaryiff is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
 
 #include <libroaryiff.h>