Index: libroaresd/AUTHORS.esd
===================================================================
--- libroaresd/AUTHORS.esd	(revision 705)
+++ libroaresd/AUTHORS.esd	(revision 705)
@@ -0,0 +1,74 @@
+This file is taken from my copy of EsounD (debian pkg) without any
+modification expect this header.
+For more information see the EsounD sources and/or contact the current
+EsounD mainteiner(s).
+-------------------------------
+
+Program History:
+
+    EsounD was coded and maintained by Eric B. Mitchell (aka 'Ricdude) <ericmit@ix.netcom.com>
+    before moving on to other things.
+
+    This was based on a prototype sound daemon created by Carsten 
+    Haitzler (aka The Rasterman).  Some snips of his code are 
+    probably still lurking about, but the overwhelming majority 
+    of it was written from scratch.
+
+Additional Credits:
+
+    Chutt <#E>, for insanely agreeing to alpha test, and porting 
+    Emusic, to EsounD.  Emusic is a highly customizable sound player
+    available from:  http://www.icom.net/~smelecat/emp3/index.htm.
+    And for the initial configure setup
+
+    Elliot Lee <sopwith@redhat.com>, for insanely jumping in and
+    carrying on, during my untimely extended leaves of absence.
+
+    Shaleh <#E>, for "-Wall -pedantic" cleanup patches
+
+    adnans <#E>, threshhold clipping patches
+
+    Peter Asobeck, Sun driver update.
+
+    Jason Ish, BSD patches and debugging.
+
+    Jeff Dubrule, mklinux driver and patches.
+
+    Vendu <#E>, remembering to check for errors in esdcat.
+
+    Brian M. Almeida, Sun driver update.
+
+    Simon Kagedal, for esdplay, a generic audio file player.
+
+    mackman, linuxppc patches.
+
+    Nick Lopez <kimo_sabe@usa.net>: ALSA port.
+
+    Dave Glowacki <dglo@SSEC.WISC.EDU>: audio_hpux patches.
+
+    Kimball Thurston: audio_irix patches.
+
+    Mandrake (Geoff Harrison) <mandrake@mandrake.net>: making sure
+    the library revision numbers actually come out right. :)
+
+    Bibek Sahu: Improved ALSA detection algorithms, filters, mixdown
+    optimizations. 
+
+    Jimmy Olsen <jo@hrp.no>: hpux driver fixes
+
+    Manish Singh <yosh@gimp.org>: misc autoconf hackery, the magic
+    /dev/dsp to esd rerouter.
+
+    Philippe Defert: aix driver fixes
+
+    Miodrag Vallat: unnecessary fsync() cleanup, rounding patch.
+
+    Bob Bell <bobbell@zk3.dec.com> is the man behind audio_osf.c
+
+    A whole list of people in the ChangeLog, who fail to appear here.
+
+    The masses of "early adopters" who beat the snot out of esound
+    early on.
+
+    Your Name Here, simply submit a patch, or port an existing 
+    application for use with this package.
Index: libroaresd/esdbasic.c
===================================================================
--- libroaresd/esdbasic.c	(revision 73)
+++ libroaresd/esdbasic.c	(revision 705)
@@ -1,3 +1,39 @@
 //esdbasic.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *  The code (may) include prototypes and comments (and maybe
+ *  other code fragements) from EsounD.
+ *  They are mostly copyrighted by Eric B. Mitchell (aka 'Ricdude)
+ *  <ericmit@ix.netcom.com>. For more information see AUTHORS.esd.
+ *
+ *  This file is part of libroaresd a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this libroar
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
 
 #include "libroaresd.h"
Index: libroaresd/esdctl.c
===================================================================
--- libroaresd/esdctl.c	(revision 631)
+++ libroaresd/esdctl.c	(revision 705)
@@ -1,3 +1,39 @@
 //esdctl.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *  The code (may) include prototypes and comments (and maybe
+ *  other code fragements) from EsounD.
+ *  They are mostly copyrighted by Eric B. Mitchell (aka 'Ricdude)
+ *  <ericmit@ix.netcom.com>. For more information see AUTHORS.esd.
+ *
+ *  This file is part of libroaresd a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this libroar
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
 
 #include "libroaresd.h"
Index: libroaresd/esdfile.c
===================================================================
--- libroaresd/esdfile.c	(revision 298)
+++ libroaresd/esdfile.c	(revision 705)
@@ -1,3 +1,39 @@
 //esdfile.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *  The code (may) include prototypes and comments (and maybe
+ *  other code fragements) from EsounD.
+ *  They are mostly copyrighted by Eric B. Mitchell (aka 'Ricdude)
+ *  <ericmit@ix.netcom.com>. For more information see AUTHORS.esd.
+ *
+ *  This file is part of libroaresd a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this libroar
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
 
 #include "libroaresd.h"
Index: libroaresd/esdsample.c
===================================================================
--- libroaresd/esdsample.c	(revision 0)
+++ libroaresd/esdsample.c	(revision 705)
@@ -1,3 +1,39 @@
 //esdsample.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *  The code (may) include prototypes and comments (and maybe
+ *  other code fragements) from EsounD.
+ *  They are mostly copyrighted by Eric B. Mitchell (aka 'Ricdude)
+ *  <ericmit@ix.netcom.com>. For more information see AUTHORS.esd.
+ *
+ *  This file is part of libroaresd a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this libroar
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
 
 #include "libroaresd.h"
Index: libroaresd/esdstream.c
===================================================================
--- libroaresd/esdstream.c	(revision 631)
+++ libroaresd/esdstream.c	(revision 705)
@@ -1,3 +1,39 @@
 //esdstream.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *  The code (may) include prototypes and comments (and maybe
+ *  other code fragements) from EsounD.
+ *  They are mostly copyrighted by Eric B. Mitchell (aka 'Ricdude)
+ *  <ericmit@ix.netcom.com>. For more information see AUTHORS.esd.
+ *
+ *  This file is part of libroaresd a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this libroar
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
 
 #include "libroaresd.h"
Index: libroaresd/libroaresd.c
===================================================================
--- libroaresd/libroaresd.c	(revision 0)
+++ libroaresd/libroaresd.c	(revision 705)
@@ -1,3 +1,39 @@
 //libroaresd.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *  The code (may) include prototypes and comments (and maybe
+ *  other code fragements) from EsounD.
+ *  They are mostly copyrighted by Eric B. Mitchell (aka 'Ricdude)
+ *  <ericmit@ix.netcom.com>. For more information see AUTHORS.esd.
+ *
+ *  This file is part of libroaresd a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this libroar
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
 
 #include "libroaresd.h"