Index: Makefile
===================================================================
--- Makefile	(revision 655)
+++ Makefile	(revision 726)
@@ -1,5 +1,5 @@
 include Makefile.conf
 
-SUBDIRS=libroar libroardsp $(subdir_libroaresd) roard roarclients $(subdir_roarfish) $(subdir_libroaryiff) $(subdir_libroarpulse) $(subdir_libroararts)
+SUBDIRS=libroar libroardsp $(subdir_libroaresd) roard roarclients doc $(subdir_roarfish) $(subdir_libroaryiff) $(subdir_libroarpulse) $(subdir_libroararts)
 
 all:
Index: include/libroar/libroar.h
===================================================================
--- include/libroar/libroar.h	(revision 690)
+++ include/libroar/libroar.h	(revision 726)
@@ -42,4 +42,5 @@
 #include <fcntl.h>
 #include <sys/socket.h>
+#include <netinet/in_systm.h>
 #include <netinet/in.h>
 #include <netinet/ip.h>
Index: libroar/Makefile
===================================================================
--- libroar/Makefile	(revision 691)
+++ libroar/Makefile	(revision 726)
@@ -6,5 +6,5 @@
 #DEFINES        = -DDEBUG
 INCLUDE = -I../include -I../include/libroar
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
 LDFLAGS = -g $(SHARED) $(LDPATH) $(lib_dnet)
 
Index: libroararts/Makefile
===================================================================
--- libroararts/Makefile	(revision 694)
+++ libroararts/Makefile	(revision 726)
@@ -6,5 +6,5 @@
 DEFINES        = -DDEBUG
 INCLUDE = -I../include -I../include/libroarpulse
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
 LDFLAGS = -g -lroar $(LDPATH) -L../lib/
 
Index: libroardsp/Makefile
===================================================================
--- libroardsp/Makefile	(revision 691)
+++ libroardsp/Makefile	(revision 726)
@@ -8,5 +8,5 @@
 #DEFINES        = -DDEBUG
 INCLUDE = -I../include -I../include/libroardsp
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
 LDFLAGS = -g $(SHARED) -L../lib/ $(LDPATH) $(lib_dnet) -lm -lroar
 
Index: libroaresd/Makefile
===================================================================
--- libroaresd/Makefile	(revision 694)
+++ libroaresd/Makefile	(revision 726)
@@ -6,6 +6,6 @@
 #DEFINES        = -DDEBUG
 INCLUDE = -I../include -I../include/libroaresd
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
-LDFLAGS = -g  -lroar $(LDPATH) -L../lib/
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
+LDFLAGS = -g $(SHARED) -lroar $(LDPATH) -L../lib/
 
 all: ${TARGETS}
Index: libroarpulse/Makefile
===================================================================
--- libroarpulse/Makefile	(revision 694)
+++ libroarpulse/Makefile	(revision 726)
@@ -6,5 +6,5 @@
 DEFINES        = -DDEBUG
 INCLUDE = -I../include -I../include/libroarpulse
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
 LDFLAGS = -g -lroar $(LDPATH) -L../lib/
 
Index: libroaryiff/Makefile
===================================================================
--- libroaryiff/Makefile	(revision 694)
+++ libroaryiff/Makefile	(revision 726)
@@ -6,5 +6,5 @@
 #DEFINES        = -DDEBUG
 INCLUDE = -I../include -I../include/libroaryiff
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) -fPIC
 LDFLAGS = -g $(SHARED) -lroar $(LDPATH) -L../lib/
 
Index: roarclients/Makefile
===================================================================
--- roarclients/Makefile	(revision 655)
+++ roarclients/Makefile	(revision 726)
@@ -5,5 +5,5 @@
 #DEFINES        = -DDEBUG
 INCLUDE = -I../include -I./include
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH)
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH)
 LDFLAGS = -g -L../lib/ $(LDPATH) -lroar
 
Index: roard/Makefile
===================================================================
--- roard/Makefile	(revision 692)
+++ roard/Makefile	(revision 726)
@@ -10,5 +10,5 @@
 #DEFINES        = -DMONITOR_LATENCY
 INCLUDE = -I../include -I./include
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH)
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH)
 LDFLAGS = -g -L../lib/ $(LDPATH) -lroar -lroardsp $(lib_esd) $(lib_ao) $(lib_vorbisfile) $(lib_vorbisenc) -lm $(lib_celt) $(lib_speex) $(lib_vorbis)
 
Index: roarfish/Makefile
===================================================================
--- roarfish/Makefile	(revision 485)
+++ roarfish/Makefile	(revision 726)
@@ -5,5 +5,5 @@
 #DEFINES        = -DDEBUG
 INCLUDE = -I../include -I./include
-CFLAGS  = -g -Wall -O2 $(DEFINES) $(INCLUDE)
+CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE)
 LDFLAGS = -g -L../lib/ $(LDPATH) -lroar -lfishsound -loggz
 